// Code generated by SQLBoiler 4.14.2 (https://github.com/volatiletech/sqlboiler). DO NOT EDIT.
// This file is meant to be re-generated in place and/or deleted at any time.

package models

import (
	"context"
	"database/sql"
	"fmt"
	"reflect"
	"strconv"
	"strings"
	"sync"
	"time"

	"github.com/friendsofgo/errors"
	"github.com/volatiletech/null/v8"
	"github.com/volatiletech/sqlboiler/v4/boil"
	"github.com/volatiletech/sqlboiler/v4/queries"
	"github.com/volatiletech/sqlboiler/v4/queries/qm"
	"github.com/volatiletech/sqlboiler/v4/queries/qmhelper"
	"github.com/volatiletech/strmangle"
)

// RevenueVehicle is an object representing the database table.
type RevenueVehicle struct {
	ID        int64      `boil:"id" json:"id" toml:"id" yaml:"id"`
	Month     null.Int   `boil:"month" json:"month,omitempty" toml:"month" yaml:"month,omitempty"`
	Year      null.Int   `boil:"year" json:"year,omitempty" toml:"year" yaml:"year,omitempty"`
	Amount    null.Int64 `boil:"amount" json:"amount,omitempty" toml:"amount" yaml:"amount,omitempty"`
	CreatedAt time.Time  `boil:"created_at" json:"created_at" toml:"created_at" yaml:"created_at"`
	UpdatedAt time.Time  `boil:"updated_at" json:"updated_at" toml:"updated_at" yaml:"updated_at"`

	R *revenueVehicleR `boil:"-" json:"-" toml:"-" yaml:"-"`
	L revenueVehicleL  `boil:"-" json:"-" toml:"-" yaml:"-"`
}

var RevenueVehicleColumns = struct {
	ID        string
	Month     string
	Year      string
	Amount    string
	CreatedAt string
	UpdatedAt string
}{
	ID:        "id",
	Month:     "month",
	Year:      "year",
	Amount:    "amount",
	CreatedAt: "created_at",
	UpdatedAt: "updated_at",
}

var RevenueVehicleTableColumns = struct {
	ID        string
	Month     string
	Year      string
	Amount    string
	CreatedAt string
	UpdatedAt string
}{
	ID:        "revenue_vehicle.id",
	Month:     "revenue_vehicle.month",
	Year:      "revenue_vehicle.year",
	Amount:    "revenue_vehicle.amount",
	CreatedAt: "revenue_vehicle.created_at",
	UpdatedAt: "revenue_vehicle.updated_at",
}

// Generated where

var RevenueVehicleWhere = struct {
	ID        whereHelperint64
	Month     whereHelpernull_Int
	Year      whereHelpernull_Int
	Amount    whereHelpernull_Int64
	CreatedAt whereHelpertime_Time
	UpdatedAt whereHelpertime_Time
}{
	ID:        whereHelperint64{field: "\"revenue_vehicle\".\"id\""},
	Month:     whereHelpernull_Int{field: "\"revenue_vehicle\".\"month\""},
	Year:      whereHelpernull_Int{field: "\"revenue_vehicle\".\"year\""},
	Amount:    whereHelpernull_Int64{field: "\"revenue_vehicle\".\"amount\""},
	CreatedAt: whereHelpertime_Time{field: "\"revenue_vehicle\".\"created_at\""},
	UpdatedAt: whereHelpertime_Time{field: "\"revenue_vehicle\".\"updated_at\""},
}

// RevenueVehicleRels is where relationship names are stored.
var RevenueVehicleRels = struct {
}{}

// revenueVehicleR is where relationships are stored.
type revenueVehicleR struct {
}

// NewStruct creates a new relationship struct
func (*revenueVehicleR) NewStruct() *revenueVehicleR {
	return &revenueVehicleR{}
}

// revenueVehicleL is where Load methods for each relationship are stored.
type revenueVehicleL struct{}

var (
	revenueVehicleAllColumns            = []string{"id", "month", "year", "amount", "created_at", "updated_at"}
	revenueVehicleColumnsWithoutDefault = []string{}
	revenueVehicleColumnsWithDefault    = []string{"id", "month", "year", "amount", "created_at", "updated_at"}
	revenueVehiclePrimaryKeyColumns     = []string{"id"}
	revenueVehicleGeneratedColumns      = []string{}
)

type (
	// RevenueVehicleSlice is an alias for a slice of pointers to RevenueVehicle.
	// This should almost always be used instead of []RevenueVehicle.
	RevenueVehicleSlice []*RevenueVehicle
	// RevenueVehicleHook is the signature for custom RevenueVehicle hook methods
	RevenueVehicleHook func(context.Context, boil.ContextExecutor, *RevenueVehicle) error

	revenueVehicleQuery struct {
		*queries.Query
	}
)

// Cache for insert, update and upsert
var (
	revenueVehicleType                 = reflect.TypeOf(&RevenueVehicle{})
	revenueVehicleMapping              = queries.MakeStructMapping(revenueVehicleType)
	revenueVehiclePrimaryKeyMapping, _ = queries.BindMapping(revenueVehicleType, revenueVehicleMapping, revenueVehiclePrimaryKeyColumns)
	revenueVehicleInsertCacheMut       sync.RWMutex
	revenueVehicleInsertCache          = make(map[string]insertCache)
	revenueVehicleUpdateCacheMut       sync.RWMutex
	revenueVehicleUpdateCache          = make(map[string]updateCache)
	revenueVehicleUpsertCacheMut       sync.RWMutex
	revenueVehicleUpsertCache          = make(map[string]insertCache)
)

var (
	// Force time package dependency for automated UpdatedAt/CreatedAt.
	_ = time.Second
	// Force qmhelper dependency for where clause generation (which doesn't
	// always happen)
	_ = qmhelper.Where
)

var revenueVehicleAfterSelectHooks []RevenueVehicleHook

var revenueVehicleBeforeInsertHooks []RevenueVehicleHook
var revenueVehicleAfterInsertHooks []RevenueVehicleHook

var revenueVehicleBeforeUpdateHooks []RevenueVehicleHook
var revenueVehicleAfterUpdateHooks []RevenueVehicleHook

var revenueVehicleBeforeDeleteHooks []RevenueVehicleHook
var revenueVehicleAfterDeleteHooks []RevenueVehicleHook

var revenueVehicleBeforeUpsertHooks []RevenueVehicleHook
var revenueVehicleAfterUpsertHooks []RevenueVehicleHook

// doAfterSelectHooks executes all "after Select" hooks.
func (o *RevenueVehicle) doAfterSelectHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range revenueVehicleAfterSelectHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doBeforeInsertHooks executes all "before insert" hooks.
func (o *RevenueVehicle) doBeforeInsertHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range revenueVehicleBeforeInsertHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterInsertHooks executes all "after Insert" hooks.
func (o *RevenueVehicle) doAfterInsertHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range revenueVehicleAfterInsertHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doBeforeUpdateHooks executes all "before Update" hooks.
func (o *RevenueVehicle) doBeforeUpdateHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range revenueVehicleBeforeUpdateHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterUpdateHooks executes all "after Update" hooks.
func (o *RevenueVehicle) doAfterUpdateHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range revenueVehicleAfterUpdateHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doBeforeDeleteHooks executes all "before Delete" hooks.
func (o *RevenueVehicle) doBeforeDeleteHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range revenueVehicleBeforeDeleteHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterDeleteHooks executes all "after Delete" hooks.
func (o *RevenueVehicle) doAfterDeleteHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range revenueVehicleAfterDeleteHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doBeforeUpsertHooks executes all "before Upsert" hooks.
func (o *RevenueVehicle) doBeforeUpsertHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range revenueVehicleBeforeUpsertHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterUpsertHooks executes all "after Upsert" hooks.
func (o *RevenueVehicle) doAfterUpsertHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range revenueVehicleAfterUpsertHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// AddRevenueVehicleHook registers your hook function for all future operations.
func AddRevenueVehicleHook(hookPoint boil.HookPoint, revenueVehicleHook RevenueVehicleHook) {
	switch hookPoint {
	case boil.AfterSelectHook:
		revenueVehicleAfterSelectHooks = append(revenueVehicleAfterSelectHooks, revenueVehicleHook)
	case boil.BeforeInsertHook:
		revenueVehicleBeforeInsertHooks = append(revenueVehicleBeforeInsertHooks, revenueVehicleHook)
	case boil.AfterInsertHook:
		revenueVehicleAfterInsertHooks = append(revenueVehicleAfterInsertHooks, revenueVehicleHook)
	case boil.BeforeUpdateHook:
		revenueVehicleBeforeUpdateHooks = append(revenueVehicleBeforeUpdateHooks, revenueVehicleHook)
	case boil.AfterUpdateHook:
		revenueVehicleAfterUpdateHooks = append(revenueVehicleAfterUpdateHooks, revenueVehicleHook)
	case boil.BeforeDeleteHook:
		revenueVehicleBeforeDeleteHooks = append(revenueVehicleBeforeDeleteHooks, revenueVehicleHook)
	case boil.AfterDeleteHook:
		revenueVehicleAfterDeleteHooks = append(revenueVehicleAfterDeleteHooks, revenueVehicleHook)
	case boil.BeforeUpsertHook:
		revenueVehicleBeforeUpsertHooks = append(revenueVehicleBeforeUpsertHooks, revenueVehicleHook)
	case boil.AfterUpsertHook:
		revenueVehicleAfterUpsertHooks = append(revenueVehicleAfterUpsertHooks, revenueVehicleHook)
	}
}

// One returns a single revenueVehicle record from the query.
func (q revenueVehicleQuery) One(ctx context.Context, exec boil.ContextExecutor) (*RevenueVehicle, error) {
	o := &RevenueVehicle{}

	queries.SetLimit(q.Query, 1)

	err := q.Bind(ctx, exec, o)
	if err != nil {
		if errors.Is(err, sql.ErrNoRows) {
			return nil, sql.ErrNoRows
		}
		return nil, errors.Wrap(err, "models: failed to execute a one query for revenue_vehicle")
	}

	if err := o.doAfterSelectHooks(ctx, exec); err != nil {
		return o, err
	}

	return o, nil
}

// All returns all RevenueVehicle records from the query.
func (q revenueVehicleQuery) All(ctx context.Context, exec boil.ContextExecutor) (RevenueVehicleSlice, error) {
	var o []*RevenueVehicle

	err := q.Bind(ctx, exec, &o)
	if err != nil {
		return nil, errors.Wrap(err, "models: failed to assign all query results to RevenueVehicle slice")
	}

	if len(revenueVehicleAfterSelectHooks) != 0 {
		for _, obj := range o {
			if err := obj.doAfterSelectHooks(ctx, exec); err != nil {
				return o, err
			}
		}
	}

	return o, nil
}

// Count returns the count of all RevenueVehicle records in the query.
func (q revenueVehicleQuery) Count(ctx context.Context, exec boil.ContextExecutor) (int64, error) {
	var count int64

	queries.SetSelect(q.Query, nil)
	queries.SetCount(q.Query)

	err := q.Query.QueryRowContext(ctx, exec).Scan(&count)
	if err != nil {
		return 0, errors.Wrap(err, "models: failed to count revenue_vehicle rows")
	}

	return count, nil
}

// Exists checks if the row exists in the table.
func (q revenueVehicleQuery) Exists(ctx context.Context, exec boil.ContextExecutor) (bool, error) {
	var count int64

	queries.SetSelect(q.Query, nil)
	queries.SetCount(q.Query)
	queries.SetLimit(q.Query, 1)

	err := q.Query.QueryRowContext(ctx, exec).Scan(&count)
	if err != nil {
		return false, errors.Wrap(err, "models: failed to check if revenue_vehicle exists")
	}

	return count > 0, nil
}

// RevenueVehicles retrieves all the records using an executor.
func RevenueVehicles(mods ...qm.QueryMod) revenueVehicleQuery {
	mods = append(mods, qm.From("\"revenue_vehicle\""))
	q := NewQuery(mods...)
	if len(queries.GetSelect(q)) == 0 {
		queries.SetSelect(q, []string{"\"revenue_vehicle\".*"})
	}

	return revenueVehicleQuery{q}
}

// FindRevenueVehicle retrieves a single record by ID with an executor.
// If selectCols is empty Find will return all columns.
func FindRevenueVehicle(ctx context.Context, exec boil.ContextExecutor, iD int64, selectCols ...string) (*RevenueVehicle, error) {
	revenueVehicleObj := &RevenueVehicle{}

	sel := "*"
	if len(selectCols) > 0 {
		sel = strings.Join(strmangle.IdentQuoteSlice(dialect.LQ, dialect.RQ, selectCols), ",")
	}
	query := fmt.Sprintf(
		"select %s from \"revenue_vehicle\" where \"id\"=$1", sel,
	)

	q := queries.Raw(query, iD)

	err := q.Bind(ctx, exec, revenueVehicleObj)
	if err != nil {
		if errors.Is(err, sql.ErrNoRows) {
			return nil, sql.ErrNoRows
		}
		return nil, errors.Wrap(err, "models: unable to select from revenue_vehicle")
	}

	if err = revenueVehicleObj.doAfterSelectHooks(ctx, exec); err != nil {
		return revenueVehicleObj, err
	}

	return revenueVehicleObj, nil
}

// Insert a single record using an executor.
// See boil.Columns.InsertColumnSet documentation to understand column list inference for inserts.
func (o *RevenueVehicle) Insert(ctx context.Context, exec boil.ContextExecutor, columns boil.Columns) error {
	if o == nil {
		return errors.New("models: no revenue_vehicle provided for insertion")
	}

	var err error
	if !boil.TimestampsAreSkipped(ctx) {
		currTime := time.Now().In(boil.GetLocation())

		if o.CreatedAt.IsZero() {
			o.CreatedAt = currTime
		}
		if o.UpdatedAt.IsZero() {
			o.UpdatedAt = currTime
		}
	}

	if err := o.doBeforeInsertHooks(ctx, exec); err != nil {
		return err
	}

	nzDefaults := queries.NonZeroDefaultSet(revenueVehicleColumnsWithDefault, o)

	key := makeCacheKey(columns, nzDefaults)
	revenueVehicleInsertCacheMut.RLock()
	cache, cached := revenueVehicleInsertCache[key]
	revenueVehicleInsertCacheMut.RUnlock()

	if !cached {
		wl, returnColumns := columns.InsertColumnSet(
			revenueVehicleAllColumns,
			revenueVehicleColumnsWithDefault,
			revenueVehicleColumnsWithoutDefault,
			nzDefaults,
		)

		cache.valueMapping, err = queries.BindMapping(revenueVehicleType, revenueVehicleMapping, wl)
		if err != nil {
			return err
		}
		cache.retMapping, err = queries.BindMapping(revenueVehicleType, revenueVehicleMapping, returnColumns)
		if err != nil {
			return err
		}
		if len(wl) != 0 {
			cache.query = fmt.Sprintf("INSERT INTO \"revenue_vehicle\" (\"%s\") %%sVALUES (%s)%%s", strings.Join(wl, "\",\""), strmangle.Placeholders(dialect.UseIndexPlaceholders, len(wl), 1, 1))
		} else {
			cache.query = "INSERT INTO \"revenue_vehicle\" %sDEFAULT VALUES%s"
		}

		var queryOutput, queryReturning string

		if len(cache.retMapping) != 0 {
			queryReturning = fmt.Sprintf(" RETURNING \"%s\"", strings.Join(returnColumns, "\",\""))
		}

		cache.query = fmt.Sprintf(cache.query, queryOutput, queryReturning)
	}

	value := reflect.Indirect(reflect.ValueOf(o))
	vals := queries.ValuesFromMapping(value, cache.valueMapping)

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, cache.query)
		fmt.Fprintln(writer, vals)
	}

	if len(cache.retMapping) != 0 {
		err = exec.QueryRowContext(ctx, cache.query, vals...).Scan(queries.PtrsFromMapping(value, cache.retMapping)...)
	} else {
		_, err = exec.ExecContext(ctx, cache.query, vals...)
	}

	if err != nil {
		return errors.Wrap(err, "models: unable to insert into revenue_vehicle")
	}

	if !cached {
		revenueVehicleInsertCacheMut.Lock()
		revenueVehicleInsertCache[key] = cache
		revenueVehicleInsertCacheMut.Unlock()
	}

	return o.doAfterInsertHooks(ctx, exec)
}

// Update uses an executor to update the RevenueVehicle.
// See boil.Columns.UpdateColumnSet documentation to understand column list inference for updates.
// Update does not automatically update the record in case of default values. Use .Reload() to refresh the records.
func (o *RevenueVehicle) Update(ctx context.Context, exec boil.ContextExecutor, columns boil.Columns) (int64, error) {
	if !boil.TimestampsAreSkipped(ctx) {
		currTime := time.Now().In(boil.GetLocation())

		o.UpdatedAt = currTime
	}

	var err error
	if err = o.doBeforeUpdateHooks(ctx, exec); err != nil {
		return 0, err
	}
	key := makeCacheKey(columns, nil)
	revenueVehicleUpdateCacheMut.RLock()
	cache, cached := revenueVehicleUpdateCache[key]
	revenueVehicleUpdateCacheMut.RUnlock()

	if !cached {
		wl := columns.UpdateColumnSet(
			revenueVehicleAllColumns,
			revenueVehiclePrimaryKeyColumns,
		)

		if !columns.IsWhitelist() {
			wl = strmangle.SetComplement(wl, []string{"created_at"})
		}
		if len(wl) == 0 {
			return 0, errors.New("models: unable to update revenue_vehicle, could not build whitelist")
		}

		cache.query = fmt.Sprintf("UPDATE \"revenue_vehicle\" SET %s WHERE %s",
			strmangle.SetParamNames("\"", "\"", 1, wl),
			strmangle.WhereClause("\"", "\"", len(wl)+1, revenueVehiclePrimaryKeyColumns),
		)
		cache.valueMapping, err = queries.BindMapping(revenueVehicleType, revenueVehicleMapping, append(wl, revenueVehiclePrimaryKeyColumns...))
		if err != nil {
			return 0, err
		}
	}

	values := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(o)), cache.valueMapping)

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, cache.query)
		fmt.Fprintln(writer, values)
	}
	var result sql.Result
	result, err = exec.ExecContext(ctx, cache.query, values...)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to update revenue_vehicle row")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: failed to get rows affected by update for revenue_vehicle")
	}

	if !cached {
		revenueVehicleUpdateCacheMut.Lock()
		revenueVehicleUpdateCache[key] = cache
		revenueVehicleUpdateCacheMut.Unlock()
	}

	return rowsAff, o.doAfterUpdateHooks(ctx, exec)
}

// UpdateAll updates all rows with the specified column values.
func (q revenueVehicleQuery) UpdateAll(ctx context.Context, exec boil.ContextExecutor, cols M) (int64, error) {
	queries.SetUpdate(q.Query, cols)

	result, err := q.Query.ExecContext(ctx, exec)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to update all for revenue_vehicle")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to retrieve rows affected for revenue_vehicle")
	}

	return rowsAff, nil
}

// UpdateAll updates all rows with the specified column values, using an executor.
func (o RevenueVehicleSlice) UpdateAll(ctx context.Context, exec boil.ContextExecutor, cols M) (int64, error) {
	ln := int64(len(o))
	if ln == 0 {
		return 0, nil
	}

	if len(cols) == 0 {
		return 0, errors.New("models: update all requires at least one column argument")
	}

	colNames := make([]string, len(cols))
	args := make([]interface{}, len(cols))

	i := 0
	for name, value := range cols {
		colNames[i] = name
		args[i] = value
		i++
	}

	// Append all of the primary key values for each column
	for _, obj := range o {
		pkeyArgs := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(obj)), revenueVehiclePrimaryKeyMapping)
		args = append(args, pkeyArgs...)
	}

	sql := fmt.Sprintf("UPDATE \"revenue_vehicle\" SET %s WHERE %s",
		strmangle.SetParamNames("\"", "\"", 1, colNames),
		strmangle.WhereClauseRepeated(string(dialect.LQ), string(dialect.RQ), len(colNames)+1, revenueVehiclePrimaryKeyColumns, len(o)))

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, sql)
		fmt.Fprintln(writer, args...)
	}
	result, err := exec.ExecContext(ctx, sql, args...)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to update all in revenueVehicle slice")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to retrieve rows affected all in update all revenueVehicle")
	}
	return rowsAff, nil
}

// Upsert attempts an insert using an executor, and does an update or ignore on conflict.
// See boil.Columns documentation for how to properly use updateColumns and insertColumns.
func (o *RevenueVehicle) Upsert(ctx context.Context, exec boil.ContextExecutor, updateOnConflict bool, conflictColumns []string, updateColumns, insertColumns boil.Columns) error {
	if o == nil {
		return errors.New("models: no revenue_vehicle provided for upsert")
	}
	if !boil.TimestampsAreSkipped(ctx) {
		currTime := time.Now().In(boil.GetLocation())

		if o.CreatedAt.IsZero() {
			o.CreatedAt = currTime
		}
		o.UpdatedAt = currTime
	}

	if err := o.doBeforeUpsertHooks(ctx, exec); err != nil {
		return err
	}

	nzDefaults := queries.NonZeroDefaultSet(revenueVehicleColumnsWithDefault, o)

	// Build cache key in-line uglily - mysql vs psql problems
	buf := strmangle.GetBuffer()
	if updateOnConflict {
		buf.WriteByte('t')
	} else {
		buf.WriteByte('f')
	}
	buf.WriteByte('.')
	for _, c := range conflictColumns {
		buf.WriteString(c)
	}
	buf.WriteByte('.')
	buf.WriteString(strconv.Itoa(updateColumns.Kind))
	for _, c := range updateColumns.Cols {
		buf.WriteString(c)
	}
	buf.WriteByte('.')
	buf.WriteString(strconv.Itoa(insertColumns.Kind))
	for _, c := range insertColumns.Cols {
		buf.WriteString(c)
	}
	buf.WriteByte('.')
	for _, c := range nzDefaults {
		buf.WriteString(c)
	}
	key := buf.String()
	strmangle.PutBuffer(buf)

	revenueVehicleUpsertCacheMut.RLock()
	cache, cached := revenueVehicleUpsertCache[key]
	revenueVehicleUpsertCacheMut.RUnlock()

	var err error

	if !cached {
		insert, ret := insertColumns.InsertColumnSet(
			revenueVehicleAllColumns,
			revenueVehicleColumnsWithDefault,
			revenueVehicleColumnsWithoutDefault,
			nzDefaults,
		)

		update := updateColumns.UpdateColumnSet(
			revenueVehicleAllColumns,
			revenueVehiclePrimaryKeyColumns,
		)

		if updateOnConflict && len(update) == 0 {
			return errors.New("models: unable to upsert revenue_vehicle, could not build update column list")
		}

		conflict := conflictColumns
		if len(conflict) == 0 {
			conflict = make([]string, len(revenueVehiclePrimaryKeyColumns))
			copy(conflict, revenueVehiclePrimaryKeyColumns)
		}
		cache.query = buildUpsertQueryPostgres(dialect, "\"revenue_vehicle\"", updateOnConflict, ret, update, conflict, insert)

		cache.valueMapping, err = queries.BindMapping(revenueVehicleType, revenueVehicleMapping, insert)
		if err != nil {
			return err
		}
		if len(ret) != 0 {
			cache.retMapping, err = queries.BindMapping(revenueVehicleType, revenueVehicleMapping, ret)
			if err != nil {
				return err
			}
		}
	}

	value := reflect.Indirect(reflect.ValueOf(o))
	vals := queries.ValuesFromMapping(value, cache.valueMapping)
	var returns []interface{}
	if len(cache.retMapping) != 0 {
		returns = queries.PtrsFromMapping(value, cache.retMapping)
	}

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, cache.query)
		fmt.Fprintln(writer, vals)
	}
	if len(cache.retMapping) != 0 {
		err = exec.QueryRowContext(ctx, cache.query, vals...).Scan(returns...)
		if errors.Is(err, sql.ErrNoRows) {
			err = nil // Postgres doesn't return anything when there's no update
		}
	} else {
		_, err = exec.ExecContext(ctx, cache.query, vals...)
	}
	if err != nil {
		return errors.Wrap(err, "models: unable to upsert revenue_vehicle")
	}

	if !cached {
		revenueVehicleUpsertCacheMut.Lock()
		revenueVehicleUpsertCache[key] = cache
		revenueVehicleUpsertCacheMut.Unlock()
	}

	return o.doAfterUpsertHooks(ctx, exec)
}

// Delete deletes a single RevenueVehicle record with an executor.
// Delete will match against the primary key column to find the record to delete.
func (o *RevenueVehicle) Delete(ctx context.Context, exec boil.ContextExecutor) (int64, error) {
	if o == nil {
		return 0, errors.New("models: no RevenueVehicle provided for delete")
	}

	if err := o.doBeforeDeleteHooks(ctx, exec); err != nil {
		return 0, err
	}

	args := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(o)), revenueVehiclePrimaryKeyMapping)
	sql := "DELETE FROM \"revenue_vehicle\" WHERE \"id\"=$1"

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, sql)
		fmt.Fprintln(writer, args...)
	}
	result, err := exec.ExecContext(ctx, sql, args...)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to delete from revenue_vehicle")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: failed to get rows affected by delete for revenue_vehicle")
	}

	if err := o.doAfterDeleteHooks(ctx, exec); err != nil {
		return 0, err
	}

	return rowsAff, nil
}

// DeleteAll deletes all matching rows.
func (q revenueVehicleQuery) DeleteAll(ctx context.Context, exec boil.ContextExecutor) (int64, error) {
	if q.Query == nil {
		return 0, errors.New("models: no revenueVehicleQuery provided for delete all")
	}

	queries.SetDelete(q.Query)

	result, err := q.Query.ExecContext(ctx, exec)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to delete all from revenue_vehicle")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: failed to get rows affected by deleteall for revenue_vehicle")
	}

	return rowsAff, nil
}

// DeleteAll deletes all rows in the slice, using an executor.
func (o RevenueVehicleSlice) DeleteAll(ctx context.Context, exec boil.ContextExecutor) (int64, error) {
	if len(o) == 0 {
		return 0, nil
	}

	if len(revenueVehicleBeforeDeleteHooks) != 0 {
		for _, obj := range o {
			if err := obj.doBeforeDeleteHooks(ctx, exec); err != nil {
				return 0, err
			}
		}
	}

	var args []interface{}
	for _, obj := range o {
		pkeyArgs := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(obj)), revenueVehiclePrimaryKeyMapping)
		args = append(args, pkeyArgs...)
	}

	sql := "DELETE FROM \"revenue_vehicle\" WHERE " +
		strmangle.WhereClauseRepeated(string(dialect.LQ), string(dialect.RQ), 1, revenueVehiclePrimaryKeyColumns, len(o))

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, sql)
		fmt.Fprintln(writer, args)
	}
	result, err := exec.ExecContext(ctx, sql, args...)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to delete all from revenueVehicle slice")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: failed to get rows affected by deleteall for revenue_vehicle")
	}

	if len(revenueVehicleAfterDeleteHooks) != 0 {
		for _, obj := range o {
			if err := obj.doAfterDeleteHooks(ctx, exec); err != nil {
				return 0, err
			}
		}
	}

	return rowsAff, nil
}

// Reload refetches the object from the database
// using the primary keys with an executor.
func (o *RevenueVehicle) Reload(ctx context.Context, exec boil.ContextExecutor) error {
	ret, err := FindRevenueVehicle(ctx, exec, o.ID)
	if err != nil {
		return err
	}

	*o = *ret
	return nil
}

// ReloadAll refetches every row with matching primary key column values
// and overwrites the original object slice with the newly updated slice.
func (o *RevenueVehicleSlice) ReloadAll(ctx context.Context, exec boil.ContextExecutor) error {
	if o == nil || len(*o) == 0 {
		return nil
	}

	slice := RevenueVehicleSlice{}
	var args []interface{}
	for _, obj := range *o {
		pkeyArgs := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(obj)), revenueVehiclePrimaryKeyMapping)
		args = append(args, pkeyArgs...)
	}

	sql := "SELECT \"revenue_vehicle\".* FROM \"revenue_vehicle\" WHERE " +
		strmangle.WhereClauseRepeated(string(dialect.LQ), string(dialect.RQ), 1, revenueVehiclePrimaryKeyColumns, len(*o))

	q := queries.Raw(sql, args...)

	err := q.Bind(ctx, exec, &slice)
	if err != nil {
		return errors.Wrap(err, "models: unable to reload all in RevenueVehicleSlice")
	}

	*o = slice

	return nil
}

// RevenueVehicleExists checks if the RevenueVehicle row exists.
func RevenueVehicleExists(ctx context.Context, exec boil.ContextExecutor, iD int64) (bool, error) {
	var exists bool
	sql := "select exists(select 1 from \"revenue_vehicle\" where \"id\"=$1 limit 1)"

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, sql)
		fmt.Fprintln(writer, iD)
	}
	row := exec.QueryRowContext(ctx, sql, iD)

	err := row.Scan(&exists)
	if err != nil {
		return false, errors.Wrap(err, "models: unable to check if revenue_vehicle exists")
	}

	return exists, nil
}

// Exists checks if the RevenueVehicle row exists.
func (o *RevenueVehicle) Exists(ctx context.Context, exec boil.ContextExecutor) (bool, error) {
	return RevenueVehicleExists(ctx, exec, o.ID)
}
